package net.sf.xolite.transform;


import javax.xml.transform.sax.SAXResult;

import org.xml.sax.XMLReader;

import net.sf.xolite.XMLObjectFactory;
import net.sf.xolite.XMLParseException;
import net.sf.xolite.XMLSerializable;
import net.sf.xolite.impl.RootHolder;
import net.sf.xolite.sax.SaxXMLEventParser;


public class XMLEventParserResult extends SAXResult {


    private SaxXMLEventParser parser;
    private XMLSerializable root;
    private boolean useRootHolder;


    public XMLEventParserResult() {
        this(new RootHolder());
        useRootHolder = true;
    }


    public XMLEventParserResult(XMLSerializable rootObject) {
        if (rootObject == null) throw new IllegalArgumentException("Root XMLSerializable object cannot be null");
        root = rootObject;
        parser = new SaxXMLEventParser((XMLReader) null);
        setHandler(parser.initForExternalRead(root));
    }


    public void setXmlObjectFactory(XMLObjectFactory factory) {
        parser.setFactory(factory);
    }


    public XMLObjectFactory getXmlObjectFactory() throws XMLParseException {
        return parser.getFactory();
    }


    public XMLSerializable getParsedObject() {
        if (useRootHolder) return ((RootHolder) root).getRoot();
        return root;
    }
    
    
}
